#include <FastLED.h>
#include "ESP8266WiFi.h"
#include "ESP8266HTTPClient.h"
#define DATA_PIN    3
#define LED_TYPE    WS2812B
#define COLOR_ORDER GRB
#define NUM_LEDS    56
CRGB leds[NUM_LEDS];
long myTimerBW = 0;
long myTimeoutBW = 60000;
String soc;
String ladeleistung;
String lademodus;
int fade = 0;
int socint;
int socfinal;
float Lmax = 7400; //Ladeleistung maximal in W angeben
float divider = (16000 / Lmax);

void setup() {
  pinMode(0, INPUT);
delay(3000);
FastLED.addLeds<LED_TYPE,DATA_PIN,COLOR_ORDER>(leds, NUM_LEDS).setCorrection(TypicalLEDStrip);
FastLED.setBrightness(255);
WiFi.mode(WIFI_STA); 
WiFi.begin("SSID", "PASSWORT");
while (WiFi.status() != WL_CONNECTED) {
delay(500);
  fill_solid(leds, NUM_LEDS, CHSV(0, 0, 0));
  FastLED.show();
}
}

void loop(){
if(digitalRead (0) == HIGH){
 if (millis() > myTimeoutBW + myTimerBW) {
   myTimerBW = millis();
  HTTPClient http1;
  HTTPClient http2;
  HTTPClient http3;
http1.begin("http://IP_DER_OPENWB/openWB/ramdisk/lademodus");
 int httpCode1 = http1.GET();
 if (httpCode1 > 0) {
lademodus = http1.getString();
 http1.end();   //Close connection
 }
 http2.begin("http://IP_DER_OPENWB/openWB/ramdisk/soc1");
  int httpCode2 = http2.GET();
 if (httpCode2 > 0) {
soc = http2.getString();
socfinal = round(soc.toInt()/5);
 http2.end();   //Close connection
 }
  http3.begin("http://IP_DER_OPENWB/openWB/ramdisk/llaktuell");
  int httpCode3 = http3.GET();
 if (httpCode3 > 0) {
ladeleistung = http3.getString();
 http3.end();   //Close connection
 }
float ladeleistungf = ladeleistung.toFloat()/1000;
float ladeleistungd = ladeleistungf * divider;
int ladeleistungfinal = round(ladeleistungd);
socint = soc.toInt();


 if (fade == 0) {
 //Farbe für Lademodi setzen
fade = 1;
for( int j = 0; j < 101; j++) {
for( int i = 0; i < 5; i++) {
 if (lademodus.indexOf("0") >= 0) {
    leds[i] = CRGB( 0, j, 0);
 } else if (lademodus.indexOf("2") >= 0) {
    leds[i] = CRGB( 0, 0, j);
  } else if (lademodus.indexOf("4") >= 0) {
      leds[i] = CRGB( j, j, 0);
   } else if (lademodus.indexOf("3") >= 0) {
        leds[i] = CRGB( j, 00, 0);  
  }
  }
for( int i =32; i < 35; i++) {
 if (lademodus.indexOf("0") >= 0) {
    leds[i] = CRGB( 0, j, 0);
 } else if (lademodus.indexOf("2") >= 0) {
    leds[i] = CRGB( 0, 0, j);
  } else if (lademodus.indexOf("4") >= 0) {
      leds[i] = CRGB( j, j, 0);
   } else if (lademodus.indexOf("3") >= 0) {
        leds[i] = CRGB( j, 00, 0);  
  }
 }
   FastLED.show();
  delay (25);
 }
  //ausgeschaltete Leds setzen
  for( int i =5; i < 8; i++) {
    leds[i] = CHSV( 0, 0, 0);
  }

 //Symbolfarbe setzen
    leds[8] = CRGB( 30, 30, 30);

    //äußeren Ring setzen
      for( int i =9; i <= socfinal+8; i++) {
          for( int j = 0; j < 16; j++) {
    leds[i] = CRGB( 0, j*2, 0);
      FastLED.show();

  }
  }
    for( int i = socfinal+9; i < 29; i++) {
      for( int j = 0; j < 3; j++) {
leds[i] = CRGB( 2, 0, 0);
     FastLED.show();
  delay (15);
  }
}
    //ausgeschaltete Leds setzen
       for( int i =29; i < 32; i++) {
 leds[i] = CRGB( 0, 0, 0);
 }
     //Symbolfarbe setzen
    leds[37] = CRGB( 30, 30, 30);
        if(ladeleistung.toInt() <= 3){
      leds[37] = CRGB( 0, 0, 0);
  }
    
//inneren Ring setzen
           for( int i =38; i <= ladeleistungfinal+37; i++) {
            for( int j = 0; j < 16; j++) {
    leds[i] = CRGB( 0, 0, j*2);
        if(ladeleistung.toInt() <= 3){
      leds[i] = CRGB( 0, 0, 0);
  }
          FastLED.show();
  }
  }
   for( int i =ladeleistungfinal+38; i < 54; i++) {
      for( int j = 0; j < 3; j++) {
leds[i] = CRGB( 2, 0, 0);
            if(ladeleistung.toInt() <= 3){
      leds[i] = CRGB( 0, 0, 0);
  }
     FastLED.show();
  delay (15);
  }
}
} else if (fade == 1) {


for( int i = 0; i < 5; i++) {
 if (lademodus.indexOf("0") >= 0) {
    leds[i] = CRGB( 0, 100, 0);
 } else if (lademodus.indexOf("2") >= 0) {
    leds[i] = CRGB( 0, 0, 100);
  } else if (lademodus.indexOf("4") >= 0) {
      leds[i] = CRGB( 100, 100, 0);
   } else if (lademodus.indexOf("3") >= 0) {
        leds[i] = CRGB( 100, 00, 0);  
  }
  }
for( int i =32; i < 35; i++) {
 if (lademodus.indexOf("0") >= 0) {
    leds[i] = CRGB( 0, 100, 0);
 } else if (lademodus.indexOf("2") >= 0) {
    leds[i] = CRGB( 0, 0, 100);
  } else if (lademodus.indexOf("4") >= 0) {
      leds[i] = CRGB( 100, 100, 0);
   } else if (lademodus.indexOf("3") >= 0) {
        leds[i] = CRGB( 100, 00, 0);  
  }
 }

  //ausgeschaltete Leds setzen
  for( int i =5; i < 8; i++) {
    leds[i] = CHSV( 0, 0, 0);
  }
       for( int i =29; i < 32; i++) {
 leds[i] = CRGB( 0, 0, 0);
 }

 //Symbolfarbe setzen
    leds[8] = CRGB( 30, 30, 30);
    leds[37] = CRGB( 30, 30, 30);
    if(ladeleistung.toInt() <= 3){
      leds[37] = CRGB( 0, 0, 0);
    }


    //äußeren Ring setzen
      for( int i =9; i <= socfinal+8; i++) {
    leds[i] = CRGB( 0, 30, 0);
  }
    for( int i = socfinal+9; i < 29; i++) {
leds[i] = CRGB( 2, 0, 0);
}


//inneren Ring setzen
     for( int i =38; i <= ladeleistungfinal+37; i++) {
    leds[i] = CRGB( 0, 0, 30);
    if(ladeleistung.toInt() <= 3){
      leds[i] = CRGB( 0, 0, 0);
  }
  }
   for( int i =ladeleistungfinal+38; i < 54; i++) {
leds[i] = CRGB( 2, 0, 0);
    if(ladeleistung.toInt() <= 3){
      leds[i] = CRGB( 0, 0, 0);
  }
}
  FastLED.show();
 

 }
  } else {
if(ladeleistung.toInt() >= 3){  
for( int i =9; i < 32; i++) {
if(i <= socfinal+8){
    leds[i].g = leds[i].g + 30;
    leds[i-1].g = leds[i-1].g + 20;
    leds[i-2].g = leds[i-2].g + 10;
   }else {
   leds[i] = CRGB( 2, 0, 0);
   }
      FastLED.show(); 
  delay(10);
  if(i <= socfinal+8){
    leds[i].g = leds[i].g - 30;
    leds[i-1].g = leds[i-1].g - 20;
    leds[i-2].g = leds[i-2].g - 10;
      }else {
   leds[i] = CRGB( 2, 0, 0);
   }
      delay(10);
  }

       delay(2500);
  }   
 }
 }
if(digitalRead (0) == LOW){
  if(fade == 1){
  for( int i =56; i >= 0; i--) {
  leds[i] = CRGB( 0, 0, 0);
  FastLED.show();
  delay(35);
  }
  }
  fade = 0;
  long myTimerBW = 0;
   fill_solid(leds, NUM_LEDS, CHSV(0, 0, 0));
  FastLED.show();
         delay(1000);
  }


}
